# Build with Kerberos 5 support.
%define with_krb5 1
# Build with SSL support.
%define with_ssl 1
# Build with support for xinetd and system-auth (RHL 7 and later).
%define build_7 1

Summary: Server daemons for IMAP and POP network mail protocols.
Name: imap
Version: 2000
Release: 3mdir2
Epoch: 1
Copyright: BSD
Group: System Environment/Daemons
URL: http://www.washington.edu/imap/
Source: ftp://ftp.cac.washington.edu/imap/imap-%{version}.tar.Z
Source1: imap.pamd
Source2: imap.pamd.6
Source3: imap-xinetd
Source4: ipop2-xinetd
Source5: ipop3-xinetd
Source6: imaps-xinetd
Source7: pop3s-xinetd
Source8: flock.c
Source9: poppasswd
Patch0: imap-2000-ssl.patch
Patch1: imap-2000-linux.patch
Patch2: imap-2000-vfs.patch
Patch3: imap-2000-redhat.patch
Patch4: imap-2000-krbpath.patch
Patch5: imap-4.7c2-flock.patch
Patch6: imap-4.7c2-setcred.patch
Patch7: imap-2000-sparc.patch
Patch8: imap-2000-version.patch
Patch9: pine-4.30-boguswarning.patch
Patch10: imap-4.5-maildir980721.drhfu.patch
Patch11: imap-4.5-maildir980721-delete.patch
Patch12: imap-4.5-maildir980721-rename.patch
Patch13: imap-4.7c2-mdirlist.patch
Patch14: imap-4.5-qmail.patch
Buildroot: %{_tmppath}/%{name}-root
Requires: pam >= 0.59
%if %{build_7}
Requires: /etc/pam.d/system-auth
Prereq: xinetd
%endif
%if %{with_krb5}
BuildPrereq: krb5-devel
%endif
%if %{with_ssl}
BuildPrereq: openssl-devel
%endif

%description
The imap package provides server daemons for both the IMAP (Internet
Message Access Protocol) and POP (Post Office Protocol) mail access
protocols.  The POP protocol uses a "post office" machine to collect
mail for users and allows users to download their mail to their local
machine for reading. The IMAP protocol allows a user to read mail on a
remote machine without downloading it to their local machine.

Install the imap package if you need a server to support the IMAP or
the POP mail access protocols.

%package devel
Summary: Development tools for programs which will use the IMAP library.
Group: Development/Libraries

%description devel
The imap-devel package contains the header files and static libraries
for developing programs which will use the IMAP (Internet Message
Access Protocol) library.

%prep

%setup -q
chmod -R u+w .
%if %{with_ssl}
%patch0 -p1 -b .ssl
%endif
%patch1 -p1 -b .linux
%patch2 -p1 -b .vfs
%patch3 -p1 -b .redhat
%if %{with_krb5}
%patch4 -p1 -b .gssapi
%endif
%patch5 -p1 -b .flock
%patch6 -p1 -b .setcred
%patch7 -p1 -b .sparc
%patch8 -p1 -b .version
%patch9 -p2 -b .boguswarning
cp %{SOURCE8} src/osdep/unix/

%patch10 -p1 -b .drhfu
%patch11 -p1 -b .delete
%patch12 -p1 -b .rename
%patch13 -p1 -b .mdirlist
%patch14 -p1 -b .qmail

%build
%if %{with_ssl}
EXTRACFLAGS="$EXTRACFLAGS -I/usr/include/openssl"
%endif
%if %{with_krb5}
EXTRACFLAGS="$EXTRACFLAGS -I/usr/kerberos/include"
EXTRALDFLAGS="$EXTRALDFLAGS -L/usr/kerberos/lib"
%endif
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS -fPIC" lnp \
EXTRACFLAGS="$EXTRACFLAGS" \
EXTRALDFLAGS="$EXTRALDFLAGS" \
%if %{with_krb5}
EXTRAAUTHENTICATORS=gss \
%endif
%if %{with_ssl}
SPECIALAUTHENTICATORS=ssl \
%endif
# This line needs to be here.

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
install -m 644 ./src/ipopd/ipopd.8c $RPM_BUILD_ROOT%{_mandir}/man8/ipopd.8c
install -m 644 ./src/imapd/imapd.8c $RPM_BUILD_ROOT%{_mandir}/man8/imapd.8c
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
install -s -m 755 ./ipopd/ipop2d $RPM_BUILD_ROOT%{_sbindir}
install -s -m 755 ./ipopd/ipop3d $RPM_BUILD_ROOT%{_sbindir}
install -s -m 755 ./imapd/imapd $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
%if %{build_7}
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd $RPM_BUILD_ROOT/etc/pam.d/imap
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd $RPM_BUILD_ROOT/etc/pam.d/pop
%else
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd.6 $RPM_BUILD_ROOT/etc/pam.d/imap
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd.6 $RPM_BUILD_ROOT/etc/pam.d/pop
%endif
## Install the shared lib
#install -m 755 libimap.so.%{version} $RPM_BUILD_ROOT/usr/lib
#ln -sf libimap.so.%{version} $RPM_BUILD_ROOT/usr/lib/libimap.so

mkdir -p $RPM_BUILD_ROOT%{_libdir}
install -m 644 ./c-client/c-client.a $RPM_BUILD_ROOT%{_libdir}/
ln -s c-client.a  $RPM_BUILD_ROOT%{_libdir}/libc-client.a
mkdir -p $RPM_BUILD_ROOT%{_includedir}/imap
install -m 644 ./c-client/*.h $RPM_BUILD_ROOT%{_includedir}/imap
install -m 644 ./src/osdep/tops-20/shortsym.h $RPM_BUILD_ROOT%{_includedir}/imap

%if %{build_7}
#install service configuration files
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d/
install -m644 %{SOURCE3} $RPM_BUILD_ROOT/etc/xinetd.d/imap
install -m644 %{SOURCE4} $RPM_BUILD_ROOT/etc/xinetd.d/ipop2
install -m644 %{SOURCE5} $RPM_BUILD_ROOT/etc/xinetd.d/ipop3
install -m644 %{SOURCE6} $RPM_BUILD_ROOT/etc/xinetd.d/imaps
install -m644 %{SOURCE7} $RPM_BUILD_ROOT/etc/xinetd.d/pop3s
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{build_7}
/sbin/service xinetd reload > /dev/null 2>&1 || :
%endif

%postun
%if %{build_7}
/sbin/service xinetd reload > /dev/null 2>&1 || :
%endif

%files
%defattr(-,root,root)
%config /etc/pam.d/imap
%config /etc/pam.d/pop
%if %{build_7}
%config(noreplace) /etc/xinetd.d/*
%endif
%{_mandir}/man8/ipopd.8c*
%{_mandir}/man8/imapd.8c*
%attr(0755,root,root)	%{_sbindir}/ipop2d
%attr(0755,root,root)	%{_sbindir}/ipop3d
%attr(0755,root,root)	%{_sbindir}/imapd
%doc CPYRIGHT README docs/RELNOTES docs/naming.txt

%files devel
%defattr(-,root,root)
%doc docs/*
%{_includedir}/imap
%{_libdir}/c-client.a
%{_libdir}/libc-client.a

%changelog
* Sat Dec 02 2000 David Summers <david@summersoft.fay.ar.us>
- Release 2000-3mdir2: Inadvertently left out qmail patch to read ~/Mailbox.

* Sat Nov 11 2000 David Summers <david@summersoft.fay.ar.us>
- Updated to imap-2000-3mdir1.

* Mon Oct 31 2000 Nalin Dahyabhai <nalin@redhat.com>
- make SSL and GSS support conditional
- mark as a modified version
- quell error messages about spool directory permissions

* Thu Oct 26 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2000 final release and bump epoch to upgrade RCs
- patch to get around bug in compiler on sparc

* Fri Oct 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to RC8

* Wed Oct 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- always do a pam_setcred(DELETE) before doing a pam_end()

* Tue Oct 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- switch to internal SSL support instead of using stunnel (#18727)

* Wed Oct  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to IMAP 2000 RC7

* Thu Aug 24 2000 Nalin Dahyabhai <nalin@redhat.com>
- update flock() emulation
- ignore dotlock errors because we're all using fcntl() locks

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- modify locking to use fcntl() instead of flock() (#15779)
- add simap patches

* Wed Aug  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable mbox in top-level makefile, too (#15833)

* Tue Aug  8 2000 Nalin Dahyabhai <nalin@redhat.com>
- rename simap to imaps and spop3 to pop3s

* Tue Jul 18 2000 Bill Nottingham <notting@redhat.com>
- add description & default to xinetd file

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable the mbox driver, which is counter-intuitive
- add xinetd control files for imaps and pop3s for use with stunnel

* Thu Jul  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- don't shut down xinetd on uninstall
- use xinetd's reload, not condrestart
- add chkconfig comments to xinetd config file
- reload xinetd even if all copies of imapd will be gone
- mark xinetd config files as noreplace

* Tue Jul  4 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- change scripts

* Mon Jul  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- add "Requires: xinetd" (#11837)

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 4.7c2
- condrestart xinetd in post and postun

* Sat Jun 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable by default
- FHS fixes
- add defattr to -devel subpackage
- add libc-client.a symlink to %{_libdir}

* Thu Jun  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- modify PAM setup to use system-auth

* Mon May 22 2000 Trond Eivind Glomsrd <teg@redhat.com>
- Now uses xinetd

* Wed Apr  5 2000 Bill Nottingham <notting@redhat.com>
- remove explict krb5-configs dependency

* Sun Mar 26 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- change root:mail -> root:root

* Wed Mar  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- make kerberos support conditional at build-time

* Wed Mar  1 2000 Bill Nottingham <notting@redhat.com>
- integrate kerberos support into main tree

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- fix group
- fix description
- man pages are compressed

* Thu Jan 13 2000 Preston Brown <pbrown@redhat.com>
- create static library in a subpackage 'devel' (#5098)

* Thu Jun 10 1999 Dale Lovelace <dale@redhat.com>
- add -fPIC option for sparc mod_php3 problems

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- ipop3d service name was changed to "pop" now. Clearly somebody that hasn't
  got a clue about PAM stuff is messing around with the source.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Sat Mar 13 1999 Cristian Gafton <gafton@redhat.com>
- verson 4.5
- loose the noflock patch

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- added a -vfs patch because sys/statvfs on glibc 2.1 is different from what
  is available on the sun...
- build against glibc 2.1

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- use only fcntl locking.

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.4.
- removed g+s bit to imapd.

* Wed Jul 22 1998 Jeff Johnson <jbj@redhat.com>
- updated to 4.2.
- added g+s bit to imapd so that lock files can be created.

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Apr 08 1998 Cristian Gafton <gafton@redhat.com>
- Updated to the latest imap as of today...

* Wed Dec 10 1997 Cristian Gafton <gafton@redhat.com>
- Updated to the latest imap as of today...
- Updated the pam patch to reflect the new directory organization

* Thu Oct 23 1997 Michael K. Johnson <johnsonm@redhat.com>
- Fix patch for new PAM spec compliance.

* Thu Oct 02 1997 Michael K. Johnson <johnsonm@redhat.com>
- Comply with change in PAM spec.
- Use a buildroot.

* Mon Mar 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved from pam.conf to pam.d

* Mon Mar 03 1997 Erik Troan <ewt@redhat.com>
- Fixed buffer overrun in server_login().
